//+------------------------------------------------------------------+
//| Copyright 2006, Open Source                                      |
//                                     |
//+------------------------------------------------------------------+


#property copyright "Copyright 2006, Open Source"
#property link      " "
#include <stdlib.mqh>
#define MAGIC 943448
string Name_Expert   = "JPY H4 WPR trader ";
extern int TrailingStop     = 100;
extern int    MaxBuyOrders  = 1;  
extern int    MaxSellOrders = 1; 
extern int    BuyWPR        = -96;
extern int    SellWPR       = -4;
extern double lStopLoss     = 55;
extern double sStopLoss     = 55;
extern double TakeProfit    = 190;   
extern double TargetLevel   = 9999;      
extern int    Slippage      = 1;
extern double    LotsIfNoMM=0.1;
extern bool      UseMM=false;
extern double    MMRiskFactor=0.03;
extern double    MMBalanceExcludeAmt=0;
extern double    MMBalanceShareDivisor=1;
extern bool   IsAcctMini    = false;
extern bool   UseSound      = false;
double Lots;

color  clOpenBuy     = Blue;
color  clCloseBuy    = Aqua;
color  clOpenSell    = Red;
color  clCloseSell   = Violet;
color  clModiBuy     = Blue;
color  clModiSell    = Red;

string NameFileSound = "alert.wav";

double StartingBalance = 0;                 
bool   BuyTradeAllowed    = false;              
bool   SellTradeAllowed    = false;             

datetime prev_time=0;

//+---------------------------------------------------+
//| Closes all Buys this symbol only                  |
//+---------------------------------------------------+
void CloseAllThisSymbolBuy()
{
 
   for(int i = 0; i < OrdersTotal(); i++)
       {
       OrderSelect(i, SELECT_BY_POS);
       bool result = false;
       if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC)  
         {
           if ( OrderType() == OP_BUY)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
         }
       }
      
  return; 
}
   
//+-----------------------------------------------------+
//| Closes all Sells this symbol only                   |
//+-----------------------------------------------------+
void CloseAllThisSymbolSell()
{

   for(int i = 0; i < OrdersTotal(); i++)
      {
      OrderSelect(i, SELECT_BY_POS);
      bool result = false;
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MAGIC) 
       {
         if ( OrderType() == OP_SELL)  result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
       }
  }
                                 
  return; 
}

double CalculateMMLot()
  {
   double lot_min =MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max =MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step=MarketInfo(Symbol(),MODE_LOTSTEP);
   double lot;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
     {
      Print("CalculateMMLot: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
      return(0);
     }
   if(AccountLeverage()<=0)
     {
      Print("CalculateMMLot: invalid AccountLeverage() [",AccountLeverage(),"]");
      return(0);
     }
//--- basic formula
   lot=NormalizeDouble((AccountBalance()-MMBalanceExcludeAmt)/MMBalanceShareDivisor*MMRiskFactor/AccountLeverage()/10.0,2);
//--- additional calculation
//   ...
//--- check min, max and step
   lot=NormalizeDouble(lot/lot_step,0)*lot_step;
   if(lot<lot_min) lot=lot_min;
   if(lot>lot_max) lot=lot_max;
//---
   return(lot);
  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   
   double BuyLots, SellLots, BuyProfit, SellProfit, BuyTarget, SellTarget;
   double OrdersBUY, OrdersSELL;
   int    OrdersPerSymbol;
   Lots=0;
     
  if (UseMM)
  Lots=CalculateMMLot();
  else
  Lots=LotsIfNoMM;
     
   for(int i=0;i<OrdersTotal();i++)
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC)
           {
           OrdersPerSymbol++;
           if(OrderType()==OP_BUY)  OrdersBUY++;
           if(OrderType()==OP_SELL) OrdersSELL++;
           if(OrderType()==OP_BUY)  BuyLots += OrderLots();
           if(OrderType()==OP_SELL) SellLots += OrderLots();
           if (OrderType() == OP_BUY)  BuyProfit  +=  OrderProfit();
           if (OrderType() == OP_SELL) SellProfit +=  OrderProfit();
           }
      }
      
      BuyTarget  = Lots * TargetLevel;   
      SellTarget = Lots * TargetLevel;
   if(!IsAcctMini)
      {
      BuyTarget = BuyTarget * 10;
      SellTarget = SellTarget * 10;
      }
                      
   if(BuyProfit  > BuyTarget)  CloseAllThisSymbolBuy(); 
   if(SellProfit > SellTarget) CloseAllThisSymbolSell();
    
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }

   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }

   double diWPR0=iWPR(NULL,240,14,PRICE_MEDIAN);
   double diWPR1=iWPR(NULL,240,14,PRICE_MEDIAN);

   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   
    if(OrdersPerSymbol==0) BuyTradeAllowed=true;
    if(OrdersPerSymbol==0) SellTradeAllowed=true;
    if(OrdersBUY>MaxBuyOrders-1) BuyTradeAllowed=false;
    if(OrdersSELL>MaxSellOrders-1) SellTradeAllowed=false;
 
      if ((diWPR0<BuyWPR) && BuyTradeAllowed){   
         OpenBuy();
         return(0);
      }

      if ((diWPR1>SellWPR) && SellTradeAllowed){  
         OpenSell();
         return(0);
      }
   Trailing();
   return (0);
}

void OpenBuy()
  { 
   double ldStop, ldTake; 
   string lsComm; 
   ldStop = GetStopLossBuy();
   ldTake = GetTakeProfitBuy(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
  } 
void OpenSell()
  { 
   double ldStop, ldTake; 
   string lsComm; 
   ldStop = GetStopLossSell();
   ldTake = GetTakeProfitSell(); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
   }
   
   void Trailing()
   {
   int i=0;
   if(prev_time==iTime(NULL,PERIOD_M1,0))//checking start of the next bar
           return(0);
   prev_time=iTime(NULL,PERIOD_M1,0);

   for(i=0;i<OrdersTotal();i++)
   {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    if(OrderMagicNumber()==MAGIC)
     {
      if(OrderSymbol()==Symbol())
       {
        if(OrderType()==OP_BUY)
         {
          if(OrderStopLoss()<OrderOpenPrice())
           {
            if(TrailingStop>5)
             {
              if((iClose(NULL,PERIOD_M1,1)-OrderStopLoss())>TrailingStop*Point)
              OrderModify(OrderTicket(),OrderOpenPrice(),iClose(NULL,PERIOD_M1,1)-TrailingStop*Point,OrderTakeProfit(),0,Yellow);
             }
           }
         }
        if(OrderType()==OP_SELL)
         {                                    
          if(TrailingStop>5)
           {
            if((OrderStopLoss()-iClose(NULL,PERIOD_M1,1))>TrailingStop*Point)
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),iClose(NULL,PERIOD_M1,1)+TrailingStop*Point,OrderTakeProfit(),0,Red);
             }
           }
         }
       }
     }
   }
 }

   
  string GetCommentForOrder()
   {
  	  return(Name_Expert);
   } 
  double GetStopLossBuy()
   {
     return(Bid-lStopLoss*Point);
   } 
  double GetStopLossSell()
   {
     return(Ask+sStopLoss*Point);
   }
  double GetTakeProfitBuy()
   {
     return(Ask+TakeProfit*Point);
   } 
  double GetTakeProfitSell()
   {
     return(Bid-TakeProfit*Point);
   } 

